"""
Install method

$Id: Install.py 2 2007-12-28 13:12:55Z gael.le-mignot $
"""

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

from Products.Archetypes.Extensions.utils import install_subskin

from Products.SmartKwManager.config import PROJECT_NAME, GLOBALS, SKINS_DIR
from Products.SmartKwManager.tools.SmartKwManagerTool import SmartKwManagerTool



def install(self):
    """
    Install this product
    """
    out = StringIO()
    print >> out, 'Installing %s' % PROJECT_NAME

    ## Install skin
    install_subskin(self, out, GLOBALS, SKINS_DIR)
    print >> out, 'Installed skin.'

    ## Add tool
    portal = getToolByName(self, 'portal_url').getPortalObject()
    if getToolByName(portal, SmartKwManagerTool.id, None) is None:
        t = SmartKwManagerTool()
        portal._setObject(SmartKwManagerTool.id, t)

    ## Add UID index
    pc = getToolByName(self, 'portal_catalog')
    if 'UID' not in pc.indexes():
        pc.addIndex('UID', 'FieldIndex')
        pc.addColumn('UID')
        out.write('Added UID index to portal_catalog\n')

    ## Create action
    at = getToolByName(self, 'portal_actions') 
    try:
        at.addAction('edit-keywords',
                     name='Edit keywords',
                     action='string:${object_url}/smart_keyword_edit_form',
                     condition="python: object.portal_type=='Topic'",
                     permission='Manage portal',
                     category='object')
    except:
        pass
    return out.getvalue()

    print >> out, "Successfully installed %s." % PROJECT_NAME
    return out.getvalue()
